/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.163 by jmc, Wed May 18 22:03:57 2011 UTC revision 1.212 by jmc, Sun Mar 12 16:34:11 2017 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14        echo " ---- type of test : ----"
15        echo "  (-tlm)                   perform a Tangent Linear run"
16        echo "  (-adm|-ad)               perform an adjoint run"
17        echo "  (-oad)                   perform an OpenAD adjoint run"
18      echo "  (-mth)                   run multi-threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
19      echo "  (-mpi)                   use MPI to compile and run on 2 processors"      echo "  (-mpi)                   use MPI to compile and run on 2 processors"
20      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"
21      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"
22      echo "  (-ieee/-noieee)          if possible, use IEEE compiler flags"      echo "  (-command|-c) STRING     command to run (e.g., if non-standard MPI setting)"
23      echo "                             (DEF=\"-ieee\")"      echo "                            DEF='mitgcmuv' or ='mpirun -np TR_NPROC mitgcmuv'"
24        echo " ---- testing options : ----"
25        echo "  (-optfile|-of) STRING    optfile to use"
26        echo "  (-fast)                  use optfile default for compiler flags (no '-ieee')"
27        echo "                            DEF=off => use IEEE numerics option (if available)"
28        echo "  (-devel)                 use optfile developement flags (if available)"
29      echo "  (-gsl)                   compile with \"-gsl\" flag"      echo "  (-gsl)                   compile with \"-gsl\" flag"
30      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"
     echo "  (-optfile|-of) STRING    list of optfiles to use"  
     echo "  (-addr|-a) STRING        list of email recipients"  
     echo "                             (DEF=\"\" no email is sent)"  
     echo "  (-mpackdir|-mpd) DIR     location of the mpack utility"  
     echo "                             (DEF=\"../tools/mpack-1.6\")"  
31      echo "  (-tdir|-t) STRING        list of group and/or exp. dirs to test"      echo "  (-tdir|-t) STRING        list of group and/or exp. dirs to test"
32      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
33      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 31  usage() Line 35  usage()
35      echo "                              test THIS_EXP + all the following)"      echo "                              test THIS_EXP + all the following)"
36      echo "  (-skipdir|-skd) STRING   list of exp. dirs to skip"      echo "  (-skipdir|-skd) STRING   list of exp. dirs to skip"
37      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
38      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"      echo "  (-ts)                    provide timing information per timestep"
39      echo "                             Bourne-compatible \"sh\" shell"      echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
40        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
41        echo " ---- system options : ----"
42        echo "  (-bash|-b) STRING        preferred location of a \"bash\" or \"sh\" shell"
43      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
44      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-ef) STRING             used as genmake2 \"-extra_flag\" argument"
45      echo "  (-oad)                   perform an OpenAD adjoint run"      echo "  (-ncad)                  use genmake2 option \"-nocat4ad\" (-ncad)"
46      echo "  (-command|-c) STRING     command to run"      echo "  (-small_f)               make target small_f before making target all"
47      echo "  (-makedepend|-md) STRING command to use for \"makedepend\""      echo "  (-makedepend|-md) STRING command to use for \"makedepend\""
48      echo "  (-make|-m) STRING        command to use for \"make\""      echo "  (-make|-m) STRING        command to use for \"make\""
49      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
50      echo "  (-odir) STRING           used to build output directory name"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
51      echo "                             (DEF=\"hostname\")"      echo " ---- output options : ----"
 #   echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"  
 #   echo "                             (DEF=\"1 2 3 4 5\")"  
52      echo "  (-match) NUMBER          Matching Criteria (number of digits)"      echo "  (-match) NUMBER          Matching Criteria (number of digits)"
53      echo "                             (DEF=\"$MATCH_CRIT\")"      echo "                             (DEF=\"$MATCH_CRIT\")"
54      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-odir) STRING           used to build output directory name"
55        echo "                             (DEF=\"hostname\")"
56        echo "  (-addr|-a) STRING        list of email recipients"
57        echo "                             (DEF=\"\" no email is sent)"
58        echo "  (-send)       STRING     sending command (instead of using mpack)"
59        echo "  (-savdir|-sd) STRING     location to save output tar file to send (DEF='$SAVDIR')"
60        echo "  (-mpackdir|-mpd) DIR     location of the mpack utility"
61        echo "                             (DEF=\"../tools/mpack-1.6\")"
62        echo " -- do only some parts: --"
63      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"
64      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
65        echo "  (-obj)                   only produces objects (=norun & no executable)"
66        echo "  (-src)                   only produces small '*.f' src files (not even obj)"
67        echo "                            + with: '-adm/-tlm', also makes taf outp src code"
68      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"
69      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
70      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
# Line 57  usage() Line 73  usage()
73      echo "  (-postclean|-pc)         after each exp. test, clean build-dir & run-dir"      echo "  (-postclean|-pc)         after each exp. test, clean build-dir & run-dir"
74      echo "  (-deloutp|-do)           delete output files after successful run"      echo "  (-deloutp|-do)           delete output files after successful run"
75      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
     echo "  (-ts)                    provide timing information per timestep"  
     echo "  (-papis)                 provide MFlop/s per timestep using PAPI"  
     echo "  (-pcls)                  provide MFlop/s per timestep using PCL"  
76      echo      echo
77      echo "and where STRING can be a whitespace-delimited list"      echo "and where STRING can be a whitespace-delimited list"
78      echo "such as:"      echo "such as:"
# Line 114  testoutput_var() Line 127  testoutput_var()
127      # testoutput_var dir s1 label subdir reference_output      # testoutput_var dir s1 label subdir reference_output
128      #      #
129      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
130      #     with same output from reference file $dir/results/$reference_output      #     with same output from reference file $dir/$reference_output
131      #  using search strings s1 and text label      #  using search strings s1 and text label
132    
133      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
134          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
135      fi      fi
136      if [ -r $1/$4/$OUTPUTFILE ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
137          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | nl > ${TMP}a.txt
138          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l ${TMP}a.txt | awk '{print $1}' `
139          if [ $lncntA -lt 2 ]; then          if [ $lncntA -lt 2 ]; then
140              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
141                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
142              fi              fi
143              return 99              rm -f ${TMP}a.txt ; return 99
144          fi          fi
145      else      else
146          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
147          return 99          return 99
148      fi      fi
149      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
150          echo testoutput_var: grep "$2" $1/results/$5 1>&2          echo testoutput_var: grep "$2" $1/$5 1>&2
151      fi      fi
152      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/$5 | sed 's/.*=//' | nl > ${TMP}b.txt
153      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l ${TMP}b.txt | awk '{print $1}' `
154      if [ $lncntB -lt 2 ]; then      if [ $lncntB -lt 2 ]; then
155          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
156              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
157          fi          fi
158          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
159      fi      fi
160      if [ $lncntA -ne $lncntB ]; then      if [ $lncntA -ne $lncntB ]; then
161          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
162              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
163          fi          fi
164          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
165      fi      fi
166      has_nan=`cat tmp1.txt | grep -i nan | wc -l`      has_nan=`cat ${TMP}a.txt | grep -i nan | wc -l`
167      if [ $has_nan -gt 0  ] ; then      if [ $has_nan -gt 0  ] ; then
168          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
169          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
170      fi      fi
171      has_inf=`cat tmp1.txt | grep -i inf | wc -l`      has_inf=`cat ${TMP}a.txt | grep -i inf | wc -l`
172      if [ $has_inf -gt 0  ] ; then      if [ $has_inf -gt 0  ] ; then
173          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
174          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
175      fi      fi
176      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
177          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join ${TMP}a.txt ${TMP}b.txt 1>&2
178      fi      fi
179      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
180        join ${TMP}a.txt ${TMP}b.txt | awk '{print $1 " " $2 " " $3}' | sed -e 's|:||g' > ${TMP}c.txt
181      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
182          echo testoutput_var: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
183      fi      fi
184      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
185          cat tmp3.txt 1>&2          cat ${TMP}c.txt 1>&2
186      fi      fi
187      echo "-1" >> tmp3.txt      echo "-1" >> ${TMP}c.txt
188      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      digits_of_similarity=`./tr_cmpnum < ${TMP}c.txt`
     cat tmp3.txt | sed -e 's|:||g' > tmp4.txt  
     digits_of_similarity=`./tr_cmpnum < tmp4.txt`  
189      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
190          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
191              echo testoutput_var: No comparison was available for \"$3\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
# Line 184  testoutput_var() Line 196  testoutput_var()
196              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
197          fi          fi
198      fi      fi
199      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f ${TMP}a.txt ${TMP}b.txt ${TMP}c.txt
200    
201      return $digits_of_similarity      return $digits_of_similarity
202  }  }
# Line 195  testoutput_run() Line 207  testoutput_run()
207      #      #
208      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
209  # --> same processing for adjoint & forward test  # --> same processing for adjoint & forward test
210          # default list of output variables to be checked:          # default list of output variables to be checked:
211          #  1rst : main variable used to decide if it pass or FAIL          #  1rst : main variable used to decide if it pass or FAIL
212          #  others : number of matching digits to be printed in summary.txt          #  others : number of matching digits to be printed in summary.txt
213          listChk=$DEF_CHECK_LIST          listChk=$DEF_CHECK_LIST
214          #  load experiment-specific list from file "tr_checklist" (if it exist)          #  load experiment-specific list from file "tr_checklist" (if it exist)
215          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
216          sVar=`echo $listChk | awk '{print $1}'`          sVar=`echo $listChk | awk '{print $1}'`
217          # remove 1rst var and expand the list: + => min max mean s.d          # remove 1rst var and expand the list: + => min max mean s.d
218          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
219                                 | sed 's/+//g' | sed "s/^$sVar//"`                                 | sed 's/+//g' | sed "s/^$sVar//"`
220          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
221          # check for ptracer output in reference_output file :          # set ref.outp file-name and, if compressed, uncompress it into subdir
222          outpref=$1/results/$3          refoutp=results/$3
223          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"          if test ! -r $1/results/$3 ; then
224          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"            if test -r $1/results/${3}.gz ; then
225          for ii in $PTRACERS_NUM ; do              tmpNam1=$3
226                tmpNam2=`echo $tmpNam1 | sed 's/\..*\././'`
227                if test "x$tmpNam1" = "x$tmpNam2" ; then
228                    tmpNam1=`echo $tmpNam2 | sed 's/\./.std./'`
229                fi
230                refoutp=$2/$tmpNam1
231                if [ $debug -gt 0 ]; then
232                    echo "testoutput_run: gunzip 'results/$3.gz' into '$refoutp'" 1>&2
233                fi
234                gzip -cd $1/results/${3}.gz > $1/$refoutp
235              else
236                echo "missing reference output file '$3' (.gz) in '$1/results/'"
237              fi
238            fi
239            # check for ptracer output in reference_output file :
240            if test $KIND = 0 ; then
241              ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
242              ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
243              for ii in $PTRACERS_NUM ; do
244              ptrfound=0              ptrfound=0
245              for jj in $ptr_mon ; do              for jj in $ptr_mon ; do
246                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
247                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`                  tst=`grep $name $1/$refoutp | wc -l | awk '{print $1}'`
248                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
249              done              done
250              if test $ptrfound = '1' ; then              if test $ptrfound = '1' ; then
251                  eval "HAVE_PTR0"$ii"=t"                  eval "HAVE_PTR0"$ii"=t"
252              else              else
253                  eval "HAVE_PTR0"$ii"=f"                  eval "HAVE_PTR0"$ii"=f"
               if test "x$ADM" = x -a "x$OADM" = x; then  
254                # remove this ptr from the list of output variable to check                # remove this ptr from the list of output variable to check
255                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
256                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
               fi  
257              fi              fi
258          #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2            # eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
259          done            done
260          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`          fi
261          if test $tst != 1 ; then          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
262            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2          if test $tst != 1 ; then
263                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
264            echo "==> WARNING: in checked list:" $listVar 1>&2                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
265          #- put it back once:            echo "==> WARNING: in checked list:" $listVar 1>&2
266            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`          #- put it back once:
267          fi            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
268            fi
269          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
270          echo "listVar='$listVar'" >> $locDIR"/summary.txt"          echo "listVar='$listVar'" >> $locDIR"/summary.txt"
271          #---          #---
272          allargs=""          allargs=""
273          for xx in $listVar          for xx in $listVar
274          do          do
275            case $xx in           #ii=`echo $xx | sed 's/^pt[0-9][0-9]*..$/XXX/'`        #- any ptr number
276              ii=`echo $xx | sed 's/^pt[1-9]..$/XXX/'`              #- 1 to 9 ptr number
277              if test $ii != 'XXX' ; then
278              #- all except ptracer stats:
279                case $xx in
280             'PS')  if [ $debug -gt 0 ]             'PS')  if [ $debug -gt 0 ]
281                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
282                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $refoutp ; yy=$?
283                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
284            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;            'Cost') testoutput_var $1 "ADM  ref_cost_function" "ADM CostFct" $2 $refoutp ; yy=$? ;;
285            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;           'AdGrd') testoutput_var $1 "ADM  adjoint_gradient"  "ADM Ad Grad" $2 $refoutp ; yy=$? ;;
286             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;           'FDGrd') testoutput_var $1 "ADM  finite-diff_grad"  "ADM FD Grad" $2 $refoutp ; yy=$? ;;
287             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;          'tlmCst') testoutput_var $1 "TLM  ref_cost_function" "TLM CostFct" $2 $refoutp ; yy=$? ;;
288             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;          'tlmGrd') testoutput_var $1 "TLM  tangent-lin_grad"  "TLM TL Grad" $2 $refoutp ; yy=$? ;;
289             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;          'fwdGrd') testoutput_var $1 "TLM  finite-diff_grad"  "TLM FD Grad" $2 $refoutp ; yy=$? ;;
290             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $refoutp ; yy=$? ;;
291             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $refoutp ; yy=$? ;;
292             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $refoutp ; yy=$? ;;
293             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $refoutp ; yy=$? ;;
294             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $refoutp ; yy=$? ;;
295             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $refoutp ; yy=$? ;;
296             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $refoutp ; yy=$? ;;
297             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $refoutp ; yy=$? ;;
298             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $refoutp ; yy=$? ;;
299             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $refoutp ; yy=$? ;;
300             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $refoutp ; yy=$? ;;
301             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $refoutp ; yy=$? ;;
302          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $refoutp ; yy=$? ;;
303             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $refoutp ; yy=$? ;;
304          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $refoutp ; yy=$? ;;
305             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $refoutp ; yy=$? ;;
306          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $refoutp ; yy=$? ;;
307             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $refoutp ; yy=$? ;;
308          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $refoutp ; yy=$? ;;
309             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $refoutp ; yy=$? ;;
310           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $refoutp ; yy=$? ;;
311           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $refoutp ; yy=$? ;;
312           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $refoutp ; yy=$? ;;
313           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $refoutp ; yy=$? ;;
314           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $refoutp ; yy=$? ;;
315           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $refoutp ; yy=$? ;;
316           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $refoutp ; yy=$? ;;
317           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $refoutp ; yy=$? ;;
318           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;           'uSImn') testoutput_var $1 "seaice_uice_min"   "SIce Uice min"   $2 $refoutp ; yy=$? ;;
319           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;           'uSImx') testoutput_var $1 "seaice_uice_max"   "SIce Uice max"   $2 $refoutp ; yy=$? ;;
320           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;           'uSIav') testoutput_var $1 "seaice_uice_mean"  "SIce Uice mean"  $2 $refoutp ; yy=$? ;;
321           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;           'uSIsd') testoutput_var $1 "seaice_uice_sd"    "SIce Uice StDv"  $2 $refoutp ; yy=$? ;;
322          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;           'vSImn') testoutput_var $1 "seaice_vice_min"   "SIce Vice min"   $2 $refoutp ; yy=$? ;;
323          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;           'vSImx') testoutput_var $1 "seaice_vice_max"   "SIce Vice max"   $2 $refoutp ; yy=$? ;;
324          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;           'vSIav') testoutput_var $1 "seaice_vice_mean"  "SIce Vice mean"  $2 $refoutp ; yy=$? ;;
325          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;           'vSIsd') testoutput_var $1 "seaice_vice_sd"    "SIce Vice StDv"  $2 $refoutp ; yy=$? ;;
326          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $refoutp ; yy=$? ;;
327          'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $refoutp ; yy=$? ;;
328                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $refoutp ; yy=$? ;;
329            esac          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Glob-ave"  $2 $refoutp ; yy=$? ;;
330            if test $xx = $sVar          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South-av"  $2 $refoutp ; yy=$? ;;
331            then allargs="$allargs > $yy <"          'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North-av"  $2 $refoutp ; yy=$? ;;
332            else allargs="$allargs $yy"          'HthMxS') testoutput_var $1 "thSI_IceH_max_S" "thSIc H South-max" $2 $refoutp ; yy=$? ;;
333            'HthMxN') testoutput_var $1 "thSI_IceH_max_N" "thSIc H North-max" $2 $refoutp ; yy=$? ;;
334             'sbo_M') testoutput_var $1 "sbo_mass"          "SBO mass"        $2 $refoutp ; yy=$? ;;
335             'sboFW') testoutput_var $1 "sbo_mass_fw"       "SBO m-FW"        $2 $refoutp ; yy=$? ;;
336             'sboAc') testoutput_var $1 "sbo_zoamc"         "SBO AM-C"        $2 $refoutp ; yy=$? ;;
337             'sboAp') testoutput_var $1 "sbo_zoamp"         "SBO AM-P"        $2 $refoutp ; yy=$? ;;
338            'StrmIc') testoutput_var $1 "STREAMICE_FP_ERR" "StreamIce Solver" $2 $refoutp ; yy=$? ;;
339                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
340                esac
341              else
342              #- ptracers stats:
343                nn=`echo $xx | sed 's/pt//' | sed 's/..$//'`
344                ii=`echo $xx | sed 's/^pt[0-9]*//'`
345                case $ii in
346                'mn') testoutput_var $1 "trcstat_ptracer0"$nn"_min"  "p0"$nn"_min"  $2 $refoutp ; yy=$? ;;
347                'mx') testoutput_var $1 "trcstat_ptracer0"$nn"_max"  "p0"$nn"_max"  $2 $refoutp ; yy=$? ;;
348                'av') testoutput_var $1 "trcstat_ptracer0"$nn"_mean" "p0"$nn"_mean" $2 $refoutp ; yy=$? ;;
349                'sd') testoutput_var $1 "trcstat_ptracer0"$nn"_sd"   "p0"$nn"_StDv" $2 $refoutp ; yy=$? ;;
350                esac
351            fi            fi
352          done            if test $xx = $sVar
353              then allargs="$allargs > $yy <"
354              else allargs="$allargs $yy"
355              fi
356            done
357    
358          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
359          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
360          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
361            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
362            echo $allargs $adNul            echo $allargs $adNul
363          else          else
364            echo $allargs            echo $allargs
365          fi          fi
366  # <-- same processing for adjoint & forward test  # <-- same processing for adjoint & forward test
# Line 328  genmakemodel() Line 383  genmakemodel()
383              if test "x$MKDEPEND" != x ; then              if test "x$MKDEPEND" != x ; then
384                  command="$command -makedepend=$MKDEPEND"                  command="$command -makedepend=$MKDEPEND"
385              fi              fi
386              if test "x$ADM" = xt ; then              if test $KIND = 4 ; then
387                  command="$command --mods=../code_ad"                  command="$command -oad -mods=../$code_dir"
             elif test "x$OADM" = xt ; then  
                 command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"  
388              else              else
389                  command="$command -mods=../code"                  command="$command -mods=../$code_dir"
390              fi              fi
391              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
392                  command="$command -optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
393              fi              fi
394              if test "x$IEEE" != x ; then              if test $OptLev = 1 ; then
395                  command="$command -ieee"                  command="$command -ieee"
396              fi              fi
397                if test $OptLev = 0 ; then
398                    command="$command -devel"
399                fi
400              if test "x$GSL" = xt ; then              if test "x$GSL" = xt ; then
401                  command="$command -gsl"                  command="$command -gsl"
402              fi              fi
# Line 354  genmakemodel() Line 410  genmakemodel()
410              if test "x$USE_R4" = xt ; then              if test "x$USE_R4" = xt ; then
411                  command="$command -use_r4"                  command="$command -use_r4"
412              fi              fi
413                if test "x$EXTRFLG" != x ; then
414                    command="$command -extra_flag $EXTRFLG"
415                fi
416                if test "x$NOCATAD" = xt ; then
417                    command="$command -nocat4ad"
418                fi
419              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
420                  command="$command -ts"                  command="$command -ts"
421              fi              fi
# Line 384  genmakemodel() Line 446  genmakemodel()
446  makeclean()  makeclean()
447  {  {
448      # makeclean directory      # makeclean directory
449      if test "x$NODEPEND" = xf ; then rm -f $1/make.tr_log ; fi      if test "x$NOGENMAKE" = xf ; then rm -f $1/make.tr_log ; fi
450      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
451          echo "make Clean skipped!"          echo "make Clean skipped!"
452      else      else
# Line 416  run_clean() Line 478  run_clean()
478      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
479          echo "run_clean skipped!"          echo "run_clean skipped!"
480      else      else
481          (        (
482              cd $1;          cd $1;
483              printf 'clean run-dir ... '          printf 'clean run-dir ... '
484              # part of what is done after "make clean" when doing "make CLEAN"          # part of what is done after "make clean" when doing "make CLEAN"
485              find . -name "*.meta" -exec rm {} \;          find . -name "*.meta" -exec rm {} \;
486              find . -name "*.data" -exec rm {} \;          find . -name "*.data" -exec rm {} \;
487              find . -name "fort.*" -exec rm {} \;          find . -name "fort.*" -exec rm {} \;
488              find . -type l -exec rm {} \;          find . -type l -exec rm {} \;
489              #- should remove executable only if sym-link (alredy done above)          #- should remove executable only if sym-link (already done above)
490              rm -f $RUNLOG *.txt STD* *diagnostics.log datetime          rm -f $RUNLOG *.txt STDOUT.* STDERR.* *diagnostics.log *.[0-9][0-9][0-9][0-9].log
491              rm -rf mnc_test_*          rm -f datetime costfinal divided.ctrl snapshot* output_adm.*.diva_*
492              rm -f *_MIT_CE_000.opt0000 costfunction*0000          rm -f *_MIT_CE_000.opt0000 costfunction*0000
493              echo successful          rm -f oad_cp.[0-9][0-9][0-9].?????
494              exit 0          rm -rf mnc_test_*
495          )          echo successful
496            exit 0
497          )
498      fi      fi
499  }  }
500    
# Line 473  makemodel() Line 537  makemodel()
537      else      else
538          cd $1;          cd $1;
539          if test -r Makefile ; then          if test -r Makefile ; then
540              printf 'make ... '              if test "x$MKSMALLF" = xt ; then
541              if test "x$ADM" = xt ; then                  printf 'make small_f ... '
542                  $MAKE adall >> make.tr_log 2>&1                  $MAKE_CMD small_f >> make.tr_log 2>&1
543              elif test "x$OADM" = xt ; then                  RETVAL=$?
544                  $MAKE adAll >> make.tr_log 2>&1                  if test "x$RETVAL" != x0 ; then
545              else                      tail make.tr_log
546                  if test "x$JOBS" = x ; then                      echo failed
547                      $MAKE >> make.tr_log 2>&1                      cp genmake.log genmake.tr_log $CDIR
548                        tail -$NBLINES_MKLOG make.tr_log > $CDIR"/make.tr_log_tail"
549                        rm -f $EXECUTABLE
550                        mk_fail=1
551                  else                  else
552                      $MAKE -j $JOBS >> make.tr_log 2>&1                      echo successful
553                  fi                  fi
554              fi              fi
555                printf "make $TARG ... "
556                $MAKE_CMD $TARG >> make.tr_log 2>&1
557              RETVAL=$?              RETVAL=$?
558              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
559                  tail make.tr_log                  tail make.tr_log
# Line 501  makemodel() Line 570  makemodel()
570              mk_fail=2              mk_fail=2
571          fi          fi
572      fi      fi
573      if test "x$ADM" = xt -a -f taf_ad.log ; then      if test $KIND = 1 -a -f taf_ftl.log ; then
574              head -1 taf_ad.log >> $CDIR"/summary.txt"          head -1 taf_ftl.log >> $CDIR"/summary.txt"
575              nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`      fi
576              nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`      if test $KIND = 2 -a -f taf_ad.log ; then
577              echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \          head -1 taf_ad.log >> $CDIR"/summary.txt"
578            nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`
579            nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`
580            if test -f taf_output ; then
581                n2er=`grep -c 'TAF *.* ERROR ' taf_output`
582                n3er=`grep -c '\*ERROR\* ' taf_output`
583                nerr=`expr $nerr + $n2er + $n3er`
584            fi
585            echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \
586                                  >> $CDIR"/summary.txt"                                  >> $CDIR"/summary.txt"
587      fi      fi
588      if test $mk_fail != 0 ; then return $mk_fail ; fi      if test $mk_fail != 0 ; then return $mk_fail ; fi
# Line 514  makemodel() Line 591  makemodel()
591    
592  mk_mpi_size()  mk_mpi_size()
593  {  {
594      # mk_mpi_size input_file output_file proc_Nb prefer_to_split_X      # mk_mpi_size input_file output_file proc_Nb threads_Nb_X threads_Nb_Y
595      #      #
596      # make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)      #  make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)
597      #     for an MPI build with no more than proc_Nb processors ;      #     for an MPI build with no more than proc_Nb processors ;
598      # return the effective number of processors.      #  ensure that enough tiles per proc (nSx,nSy) remain for the given
599        #     number of threads (nTx,nTy) ;
600        #  return the effective number of processors.
601    
602      inp=$1      inp=$1
603      out=$2      out=$2
604      np=$3      np=$3
605      dirX=$4      tx=$4
606        ty=$5
607      tmp=TTT.$$      tmp=TTT.$$
608    
609        # dirX : select with direction to favor in MPI process repartition
610        #   dirX=1 : prefer to put more proc in X direction
611        #   dirX=0 : prefer to put more proc in Y direction
612        dirX=0
613    
614      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`
615      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`
616      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`
617      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`
618    
619        #- for each direction, assume # of threads is a multiple of total number of tiles
620        nx=$px
621        if [ `expr $sx % $tx` -ne 0 -a `expr $sx \* $px % $tx` -eq 0 ] ; then
622            nx=`expr $sx \* $px / $tx`
623            if [ $verbose -gt 1 ]; then
624                echo " change px from $px to $nx to accommodate $tx threads"
625            fi
626        fi
627        ny=$py
628        if [ `expr $sy % $ty` -ne 0 -a `expr $sy \* $py % $ty` -eq 0 ] ; then
629            ny=`expr $sy \* $py / $ty`
630            if [ $verbose -gt 1 ]; then
631                echo " change py from $py to $ny to accommodate $ty threads"
632            fi
633        fi
634      #- find the largest divisor of input_file proc Nb, but not larger than $np      #- find the largest divisor of input_file proc Nb, but not larger than $np
635      pp=0      pp=0
636      i=1      i=1
637      while [ $i -le $px ] ; do      while [ $i -le $nx ] ; do
638        if [ `expr $px % $i` -eq 0 ] ; then        if [ `expr $nx % $i` -eq 0 ] ; then
639          j=1          j=1
640          while [ $j -le $py ] ; do          while [ $j -le $ny ] ; do
641            if [ `expr $py % $j` -eq 0 ] ; then            if [ `expr $ny % $j` -eq 0 ] ; then
642              ij=`expr $i \* $j`              ij=`expr $i \* $j`
643              if [ $ij -gt $pp ] ; then              if [ $ij -gt $pp ] ; then
644                  flag=1                  flag=1
# Line 631  linkdata() Line 731  linkdata()
731          (          (
732              cd $1 ; shift              cd $1 ; shift
733              echo 'linkdata from dirs:' $*              echo 'linkdata from dirs:' $*
734              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
735              for xx in $inpMPI ; do              for xx in $inpMPI ; do
736                if test -r "../"$1"/"$xx ; then                if test -r "../"$1"/"$xx ; then
737                  # found 1 _mpi sfx file in 1rst input dir and it is readable                  # found 1 _mpi sfx file in 1rst input dir and it is readable
738                  yy=`echo $xx | sed 's:\.mpi$::'`                  yy=`echo $xx | sed 's:\.mpi$::'`
739                  if test "x$MPI" = "x0" ; then                  if test "x$MPI" = "x0" ; then
740                      # not mpi test: remove symbolic link                      # not mpi test: remove symbolic link
# Line 666  linkdata() Line 766  linkdata()
766              prevDir='NONE'              prevDir='NONE'
767              for ldir in $* ; do              for ldir in $* ; do
768                  if test -d "../"$ldir -a $ldir != $prevDir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
769                      printf " ldir=${ldir}:" 1>&2                      printf " ldir=${ldir}:" 1>&2
770                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
771                      for i in $files ; do                      for i in $files ; do
772                          if test ! -d "../"$ldir/$i ; then                          if test ! -d "../"$ldir/$i ; then
# Line 701  runmodel() Line 801  runmodel()
801          if test "x$MPI" != x0 ; then          if test "x$MPI" != x0 ; then
802              #- adjust the MPI run command with the right number of Procs              #- adjust the MPI run command with the right number of Procs
803              #echo '' ; echo "  COMMAND='$COMMAND'"              #echo '' ; echo "  COMMAND='$COMMAND'"
804              COMMAND=`echo $COMMAND | sed "s/ TR_NPROC / $LOC_NPROC /"`              COMMAND=`echo $COMMAND | sed "s/ TR_NPROC/ $LOC_NPROC/"`
805              if test "x$MPI_MFILE" != x ; then              if test "x$MPI_MFILE" != x ; then
806                COMMAND=`echo $COMMAND | sed "s/ TR_MFILE / ..\/..\/$LOC_MFILE /"`                COMMAND=`echo $COMMAND | sed "s/ TR_MFILE / ..\/..\/$LOC_MFILE /"`
807              fi              fi
# Line 714  runmodel() Line 814  runmodel()
814            else rm -f $EXECUTABLE            else rm -f $EXECUTABLE
815            fi            fi
816          fi          fi
817          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
818              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
819              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
820          fi          fi
821          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
822              rm -f $RUNLOG ; touch $RUNLOG              rm -f $RUNLOG ; touch $RUNLOG
823              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
824              echo " no executable:" $EXECUTABLE >> $RUNLOG              echo " no executable:" $EXECUTABLE >> $RUNLOG
825              RETVAL=8              RETVAL=8
826              ENDVAL=-1              ENDVAL=-1
827          else          else
828            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
829              # output do not exist or is older than executable:              # output do not exist or is older than executable:
830              rm -f $OUTPUTFILE $RUNLOG ; touch $RUNLOG              rm -f $OUTPUTFILE $RUNLOG ; touch $RUNLOG
831              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
832            #- Divided Adjoint Run:
833            #  get the number of additional runs (add_DIVA_runs) from file "run_ADM_DIVA"
834                if test $KIND = 2 -a -f run_ADM_DIVA ; then
835                  adm_diva_nb=`sed -n '/^ *add_DIVA_runs\>.*=/p' run_ADM_DIVA | sed 's/ //g'`
836                  echo " Divided Adjoint Run: $adm_diva_nb" >> $RUNLOG
837                  eval "let $adm_diva_nb"
838                  if [ $add_DIVA_runs -ge 1 ] ; then
839                    rm -f costf* divided.ctrl snapshot*
840                    echo -n "(add_DIVA_runs=$add_DIVA_runs) ... "
841                    for ii in `seq 1 $add_DIVA_runs` ; do
842                      ( eval $COMMAND ) >> $RUNLOG 2>&1
843                      echo " additional DIVA run # $ii : done" >> $RUNLOG
844                      mv -f $OUTPUTFILE ${OUTPUTFILE}.diva_${ii}
845                    done
846                  fi
847                fi
848            #- special DIVA processing ends here
849              ( eval $COMMAND ) >> $RUNLOG 2>&1              ( eval $COMMAND ) >> $RUNLOG 2>&1
850              RETVAL=$?              RETVAL=$?
851              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`
# Line 742  runmodel() Line 859  runmodel()
859              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`
860              touch $RUNLOG              touch $RUNLOG
861              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
862              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
863            fi            fi
864          fi          fi
865          rm -f run.log_tmp          rm -f run.log_tmp
866          #- in all cases where OutputFile exists, report SIZE (and AD time)          #- in all cases where OutputFile exists, report SIZE and time
867          if test -f $OUTPUTFILE ; then          if test -f $OUTPUTFILE ; then
868            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \
869                  | sed 's/(PID.TID 0000.0001)     //' >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
870            if test "x$ADM" = xt ; then  #         grep -A3 'Seconds in section "ALL' $OUTPUTFILE \
871              grep -A3 'Seconds in section "ALL' $OUTPUTFILE >> $CDIR"/summary.txt"  #               | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
872            fi  #         some implementations of grep cannot do contextual searches so we
873    #         replace the above with a sed command
874              cat $OUTPUTFILE | sed -n '/Seconds in section "ALL/{N
875              N
876              N
877              p
878              }' | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
879          fi          fi
880          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
881          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
# Line 854  formatresults() Line 977  formatresults()
977          fi          fi
978      fi      fi
979      printf '  %s' $nm      printf '  %s' $nm
980        if test $KIND = 2 ; then
981            #-- apppend taf repport summary:
982            tafrep=`grep -c '^ TAF reports ' $CDIR/summary.txt`
983            if test $tafrep = 1 ; then
984                grep '^ TAF reports ' $CDIR/summary.txt | awk '{printf "  (e=%i, w=%i)",$3,$6}'
985            fi
986        fi
987      printf '\n'      printf '\n'
988    
989  }  }
# Line 862  scandirs() Line 992  scandirs()
992  {  {
993      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
994          for arg in * ; do          for arg in * ; do
995              test -f $arg/$1 && echo $arg             #test -f $arg/$1 && echo $arg
996                test -f $arg/$1 -o -f $arg/$1.gz && echo $arg
997          done          done
998      else      else
999          echo $*          echo $*
# Line 918  debug=0 Line 1049  debug=0
1049  verbose=1  verbose=1
1050  NBLINES_MKLOG=16000  NBLINES_MKLOG=16000
1051    
1052  IEEE=true  OptLev=1
 if test "x$MITGCM_IEEE" != x ; then  
     IEEE=$MITGCM_IEEE  
 fi  
1053  GSL=f  GSL=f
1054    
1055  CLEANUP=f  CLEANUP=f
# Line 941  SKIPDIRS= Line 1069  SKIPDIRS=
1069  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
1070  HAVE_MPACK=  HAVE_MPACK=
1071  MPACK=  MPACK=
1072    SENDCMD=
1073    SAVDIR='.'
1074  COMMAND=  COMMAND=
1075  MKDEPEND=  MKDEPEND=
1076  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1077      MAKE=make      MAKE=make
1078  fi  fi
1079    MAKE_CMD=
1080  if test "x$CC" = x ; then  if test "x$CC" = x ; then
1081      CC=cc      CC=cc
1082  fi  fi
1083  JOBS=  JOBS=
1084    TARG=
1085  MPI=0  MPI=0
1086  MPI_MFILE=  MPI_MFILE=
1087  MULTI_THREAD=f  MULTI_THREAD=f
1088  OUTDIR=  OUTDIR=
1089  DELDIR=  DELDIR=
1090  USE_R4=  USE_R4=
1091    EXTRFLG=
1092  ADM=  NOCATAD=
1093  OADM=  MKSMALLF=
1094    
1095    #- type of testing (KIND):
1096    #   KIND=0 : forward (= default) ;  KIND=1 : Tangent Linear with TAF ;
1097    #   KIND=2 : Adjoint with TAF ;     KIND=4 : Adjoint with OpenAD
1098    KIND=0
1099    
1100  # list of pTracers to check for monitor output  # list of pTracers to check for monitor output
1101  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
# Line 991  for ac_option ; do Line 1128  for ac_option ; do
1128          -mpackdir | --mpackdir | -mpd | --mpd) ac_prev=MPACKDIR ;;          -mpackdir | --mpackdir | -mpd | --mpd) ac_prev=MPACKDIR ;;
1129          -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*) MPACKDIR=$ac_optarg ;;          -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*) MPACKDIR=$ac_optarg ;;
1130    
1131            -send | --send ) ac_prev=SENDCMD ;;
1132            -send=* | --send=* ) SENDCMD=$ac_optarg ;;
1133            -savdir | --savdir | -sd | --sd ) ac_prev=SAVDIR ;;
1134            -savdir=* | --savdir=* | -sd=* | --sd=* ) SAVDIR=$ac_optarg ;;
1135    
1136          -tdir | --tdir | -t | --t) ac_prev=TESTDIRS ;;          -tdir | --tdir | -t | --t) ac_prev=TESTDIRS ;;
1137          -tdir=* | --tdir=* | -t=* | --t=*) TESTDIRS=$ac_optarg ;;          -tdir=* | --tdir=* | -t=* | --t=*) TESTDIRS=$ac_optarg ;;
1138          -skipdir | --skipdir | -skd | --skd) ac_prev=SKIPDIRS ;;          -skipdir | --skipdir | -skd | --skd) ac_prev=SKIPDIRS ;;
# Line 1008  for ac_option ; do Line 1150  for ac_option ; do
1150          -make | --make | -m | --m) ac_prev=MAKE ;;          -make | --make | -m | --m) ac_prev=MAKE ;;
1151          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;
1152    
1153            -repl_mk | --repl_mk ) ac_prev=MAKE_CMD ;;
1154            -repl_mk=* | --repl_mk=*) MAKE_CMD=$ac_optarg ;;
1155    
1156          -odir | --odir) ac_prev=OUTDIR ;;          -odir | --odir) ac_prev=OUTDIR ;;
1157          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;
1158    
# Line 1020  for ac_option ; do Line 1165  for ac_option ; do
1165          -j | --j) ac_prev=JOBS ;;          -j | --j) ac_prev=JOBS ;;
1166          -j=* | --j=*) JOBS=$ac_optarg ;;          -j=* | --j=*) JOBS=$ac_optarg ;;
1167    
1168            -ef | --ef) ac_prev=EXTRFLG ;;
1169            -ef=* | --ef=*) EXTRFLG=$ac_optarg ;;
1170    
1171          -clean | --clean) CLEANUP=t ; DELDIR=t ;;          -clean | --clean) CLEANUP=t ; DELDIR=t ;;
1172    
1173          -norun | --norun | -nr | --nr) NORUN=t ;;          -norun | --norun | -nr | --nr) NORUN=t ;;
1174            -obj | --obj ) TARG='obj' ; NORUN=t ;;
1175            -src | --src ) TARG='small_f' ; NORUN=t ;;
1176          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;
1177          -quick | --quick | -q | --q) QUICK=t ;;          -quick | --quick | -q | --q) QUICK=t ;;
1178          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;
# Line 1041  for ac_option ; do Line 1191  for ac_option ; do
1191    
1192          -mth) MULTI_THREAD=t ;;          -mth) MULTI_THREAD=t ;;
1193    
1194          -adm | -ad) ADM=t ;;          -tlm) if test $KIND = 0 ; then KIND=1 ; else
1195          -oad) OADM=t; NODEPEND=t ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1196                  fi ;;
1197          -ieee) IEEE=true ;;          -adm | -ad) if test $KIND = 0 ; then KIND=2 ; else
1198          -noieee) IEEE= ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1199                  fi ;;
1200            -oad) if test $KIND = 0 ; then KIND=4 ; NODEPEND=t ; else
1201                    echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1202                  fi ;;
1203            -ncad) NOCATAD=t ;;
1204            -small_f) MKSMALLF=t ;;
1205    
1206            -ieee)   echo "Warning: ignore option '-ieee' (already the default)"
1207                     printf " ... " ;;
1208            -noieee) echo "Warning: will use option '-fast' instead of '-noieee' (obsolete)"
1209                     printf " ... " ; OptLev=`expr $OptLev \* 2` ;;
1210            -fast)  OptLev=`expr $OptLev \* 2` ;;
1211            -devel) OptLev=0 ;;
1212          -gsl) GSL=t ;;          -gsl) GSL=t ;;
1213    
1214          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
# Line 1058  for ac_option ; do Line 1221  for ac_option ; do
1221    
1222          -ts) TS=t;;          -ts) TS=t;;
1223          -papis) PAPIS=t;;          -papis) PAPIS=t;;
1224          -pcls) PCL=t;;          -pcls) PCLS=t;;
1225    
1226          -*) echo "Error: unrecognized option: "$ac_option          -*) echo "Error: unrecognized option: "$ac_option
1227              usage ;;              usage ;;
# Line 1074  if test "x$QUICK" = xt ; then Line 1237  if test "x$QUICK" = xt ; then
1237      NOCLEAN=t      NOCLEAN=t
1238      NODEPEND=t      NODEPEND=t
1239  fi  fi
1240    if test "x$MAKE_CMD" = x ; then MAKE_CMD=$MAKE ; fi
1241    
1242  #- check length of MPI machine file:  #- check length of MPI machine file:
1243  if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then  if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then
1244      if test -r $MPI_MFILE ; then      if test -r $MPI_MFILE ; then
1245          nl=`wc -l $MPI_MFILE | awk '{print $1}'`          nl=`wc -l $MPI_MFILE | awk '{print $1}'`
1246          if [ $nl -lt $MPI ] ; then          if [ $nl -lt $MPI ] ; then
1247            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"
1248            usage            usage
1249          fi          fi
1250          if [ $verbose -gt 1 ]; then          if [ $verbose -gt 1 ]; then
1251              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"
1252          fi          fi
1253      else      else
1254            echo "Error: cannot access MPI_MFILE=$MPI_FILE"            echo "Error: cannot access MPI_MFILE=$MPI_FILE"
1255            usage            usage
1256      fi      fi
1257  fi  fi
1258    
1259  #- setting for forward or ADM testing  #- setting for forward or ADM testing
1260  if test "x$ADM" = xt ; then  if test $KIND = 1 ; then
1261        if test "x$TARG" = xsmall_f ; then TARG=ftltaf ; else TARG=ftlall ; fi
1262        code_dir=code_ad
1263        inputdir=input_ad
1264        ref_outp="output_tlm.txt"
1265        EXECUTABLE="mitgcmuv_ftl"
1266    elif test $KIND = 2 ; then
1267        if test "x$TARG" = x        ; then TARG=adall ; fi
1268        if test "x$TARG" = xobj     ; then TARG=adobj ; fi
1269        if test "x$TARG" = xsmall_f ; then TARG=adtaf ; fi
1270      code_dir=code_ad      code_dir=code_ad
1271      inputdir=input_ad      inputdir=input_ad
1272      ref_outp="output_adm.txt"      ref_outp="output_adm.txt"
1273      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
1274  elif test "x$OADM" = xt ; then  elif test $KIND = 4 ; then
1275        TARG=adAll
1276      code_dir=code_oad      code_dir=code_oad
1277      inputdir=input_oad      inputdir=input_oad
1278      ref_outp="output_oadm.txt"      ref_outp="output_oadm.txt"
# Line 1109  else Line 1283  else
1283      ref_outp="output.txt"      ref_outp="output.txt"
1284      EXECUTABLE="mitgcmuv"      EXECUTABLE="mitgcmuv"
1285  fi  fi
1286    if test "x$JOBS" != x ; then TARG="-j $JOBS $TARG" ; fi
1287    
1288  xx=`echo $TESTDIRS | awk '{print $1}'`  xx=`echo $TESTDIRS | awk '{print $1}'`
1289  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
# Line 1147  do Line 1322  do
1322              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1323          fi          fi
1324      else      else
1325          if test $count = 1 ; then echo -n ", \"$xx\""          if test $count = 1 ; then echo -n ", \"$xx\""
1326          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1327          fi          fi
1328      fi      fi
# Line 1155  done Line 1330  done
1330  if test $count = 1 ; then echo "" ; echo -n " ... " ; fi  if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1331  #echo 'TESTDIRS='${TESTDIRS}'<'  #echo 'TESTDIRS='${TESTDIRS}'<'
1332    
 if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  
     OPTFILE=$MITGCM_OF  
 fi  
   
1333  LOC_MFILE='tr_mpi_mfile'  LOC_MFILE='tr_mpi_mfile'
1334  RUNLOG="run.tr_log"  RUNLOG="run.tr_log"
1335  OUTPUTFILE=$ref_outp  if test "x$MPI" = x0 ; then
1336  if test "x$COMMAND" = x ; then    OUTPUTFILE=$ref_outp
1337      COMMAND="./$EXECUTABLE > $OUTPUTFILE"    if test "x$COMMAND" = x ; then COMMAND="./$EXECUTABLE > $OUTPUTFILE" ; fi
1338  fi  else
1339  if test "x$MPI" != x0 ; then    OUTPUTFILE="STDOUT.0000"
1340      OUTPUTFILE="STDOUT.0000"    if test "x$COMMAND" = x ; then COMMAND="mpirun -np TR_NPROC ./$EXECUTABLE" ; fi
1341  fi  fi
1342    
1343  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND='$COMMAND')"
1344    
1345    #TMP=./tr_$$
1346    #- try to put temporary files in system-local /tmp dir
1347    TMP=/tmp/tr_${USER}_$$
1348    touch $TMP ; retVal=$?
1349    if [ $retVal -eq 0 ] ; then
1350      if test ! -r $TMP ; then TMP=./tr_$$ ; fi
1351    else
1352      TMP=./tr_$$
1353    fi
1354    rm -f $TMP
1355    if [ $verbose -gt 1 ]; then echo " temp files: $TMP" ; fi
1356    
1357  # set the Default List of output variables to be checked:  # set the Default List of output variables to be checked:
1358  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
1359  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
1360  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
1361  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 1 ; then
1362        DEF_CHECK_LIST='tlmGrd tlmCst tlmGrd fwdGrd'
1363        EMPTY_RESULTS='.. .. ..'
1364        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1365    elif test $KIND = 2 -o $KIND = 4 ; then
1366        DEF_CHECK_LIST='AdGrd Cost AdGrd FDGrd'
1367        EMPTY_RESULTS='.. .. ..'
1368        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1369    else
1370      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1371      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1372      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1373      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1374      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
 else  
     DEF_CHECK_LIST='Grad Cost Grad'  
     EMPTY_RESULTS='.. ..'  
     LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`  
1375  fi  fi
1376    
1377  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1378  if test -x tr_cmpnum ; then  if test "x$CLEANUP" = xt -o -x tr_cmpnum ; then
1379      echo "skipping comparison code build"      echo "skipping comparison code build"
1380  else  else
1381      createcodelet      createcodelet
1382  fi  fi
1383    
1384  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1385  if test "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x -o "x$SENDCMD" != x ; then
1386      echo "skipping mpack build"      echo "skipping mpack build"
1387  else  else
1388      build_mpack      build_mpack
1389        if test "x$HAVE_MPACK" = xt ; then SENDCMD=$MPACK ; fi
1390  fi  fi
1391    
1392  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1393  CMDLINE=$0  CMDLINE=$0
1394  for xx in "$@" ; do nw=`echo $xx | wc -w`  for xx in "$@" ; do nw=`echo $xx | wc -w`
1395      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx" ; else
1396                          else CMDLINE="$CMDLINE '$xx'" ; fi        nb=`echo $xx | grep -c '='`
1397          if test $nb = 0 ; then CMDLINE="$CMDLINE '$xx'"
1398          else yy=`echo "$xx'" | sed "s/=/='/"` ;
1399                                 CMDLINE="$CMDLINE $yy" ; fi
1400        fi
1401  done  done
 #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done  
1402  MACH=`hostname`  MACH=`hostname`
1403  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1404  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
# Line 1215  BASE="tr_"$MACH"_"$DATE"_" Line 1406  BASE="tr_"$MACH"_"$DATE"_"
1406  if test "x$OUTDIR" != x ; then  if test "x$OUTDIR" != x ; then
1407      BASE="tr_"$OUTDIR"_"$DATE"_"      BASE="tr_"$OUTDIR"_"$DATE"_"
1408  else  else
1409      short_name=`hostname | sed 's/\..*$//'`     #short_name=`hostname -s | tr '[:upper:]' '[:lower:]'`
1410       # hostname -s is not universal (does work on AIX system)
1411        short_name=`hostname | sed 's/\..*$//' | tr '[:upper:]' '[:lower:]'`
1412      BASE="tr_"$short_name"_"$DATE"_"      BASE="tr_"$short_name"_"$DATE"_"
1413  fi  fi
1414  DNUM=0  DNUM=0
# Line 1252  if test "x$OPTFILE" != xNONE ; then Line 1445  if test "x$OPTFILE" != xNONE ; then
1445          echo >> $SUMMARY          echo >> $SUMMARY
1446          echo "  OPTFILE=$OPTFILE" >> $SUMMARY          echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1447      else      else
1448          echo | tee $SUMMARY          echo | tee -a $SUMMARY
1449          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee -a $SUMMARY
1450          exit 1          exit 1
1451      fi      fi
1452  else  else
# Line 1263  else Line 1456  else
1456  fi  fi
1457  echo  echo
1458  echo >> $SUMMARY  echo >> $SUMMARY
1459  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 0 ; then
1460      if [ $MATCH_CRIT -lt 10 ] ;      line_0=`printf '%s %2i' 'default' $MATCH_CRIT`
     then line_0="default  "$MATCH_CRIT ;  
     else line_0="default "$MATCH_CRIT ; fi  
1461         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1462      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1463      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="e p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1464      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="n n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1465      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1466      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
1467          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
# Line 1279  if test "x$ADM" = x -a "x$OADM" = x; the Line 1470  if test "x$ADM" = x -a "x$OADM" = x; the
1470          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1471          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
1472      done      done
1473    else
1474        line_0=`printf '%s %2i' 'default   ' $MATCH_CRIT`
1475      if test $KIND = 1 ; then
1476       #echo "TANGLIN=true" >> $SUMMARY
1477        echo "TangLin generated by TAF" >> $SUMMARY
1478      elif test $KIND = 3 ; then
1479        echo "TangLin generated by OpenAD" >> $SUMMARY
1480      elif test $KIND = 2 ; then
1481       #echo "ADJOINT=true" >> $SUMMARY
1482        echo "Adjoint generated by TAF" >> $SUMMARY
1483      else
1484        echo "Adjoint generated by OpenAD" >> $SUMMARY
1485      fi
1486      if test $KIND = 1 -o $KIND = 3 ; then
1487        line_1="G D M    C  T  F"
1488        line_2="e p a R  o  L  D"
1489      else
1490        line_1="G D M    C  A  F"
1491        line_2="e p a R  o  d  D"
1492      fi
1493        line_3="n n k u  s  G  G"
1494        line_4="2 d e n  t  r  r"
1495        echo >> $SUMMARY
1496    fi
1497    if test "x$CLEANUP" != xt ; then
1498      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1499      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
1500      echo "$line_2" | tee -a $SUMMARY      echo "$line_2" | tee -a $SUMMARY
1501      echo "$line_3" | tee -a $SUMMARY      echo "$line_3" | tee -a $SUMMARY
1502      echo "$line_4" | tee -a $SUMMARY      echo "$line_4" | tee -a $SUMMARY
1503      echo " "       | tee -a $SUMMARY      echo ""        | tee -a $SUMMARY
 else  
     echo "ADJOINT=true" >> $SUMMARY  
     echo >> $SUMMARY  
     if [ $MATCH_CRIT -lt 10 ] ;  
     then line_0="default     "$MATCH_CRIT ;  
     else line_0="default    "$MATCH_CRIT ; fi  
     echo "$line_0" | tee -a $SUMMARY  
     cat << EOF | tee -a $SUMMARY  
 G D M    C  G  
 E p a R  o  r  
 N n k u  s  a  
 2 d e n  t  d  
   
 EOF  
1504  fi  fi
1505  echo "-------------------------------------------------------------------------------"  echo "-------------------------------------------------------------------------------"
1506    
# Line 1324  for dir in $TESTDIRS ; do Line 1526  for dir in $TESTDIRS ; do
1526              rm -f $EXECUTABLE *.bak              rm -f $EXECUTABLE *.bak
1527              rm -f genmake_state genmake_*optfile genmake.log              rm -f genmake_state genmake_*optfile genmake.log
1528              rm -f SIZE.h.mpi genmake.tr_log make.tr_log              rm -f SIZE.h.mpi genmake.tr_log make.tr_log
1529                rm -rf mpi_headers
1530          )          )
1531          if test -d $dir/$rundir/CVS ; then          if test -d $dir/$rundir/CVS ; then
1532              echo -n '  --- dir:' $dir/$rundir ': '              echo -n '  --- dir:' $dir/$rundir ': '
1533              run_clean $dir/$rundir              run_clean $dir/$rundir
1534          fi          fi
1535          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`
# Line 1341  for dir in $TESTDIRS ; do Line 1544  for dir in $TESTDIRS ; do
1544      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1545      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1546      fout=$dir"/results/"$ref_outp      fout=$dir"/results/"$ref_outp
1547      if test ! -r $fout ; then     #if test ! -r $fout ; then
1548        if test ! -r $fout -a ! -r ${fout}.gz ; then
1549          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1550          continue          continue
1551      fi      fi
# Line 1358  for dir in $TESTDIRS ; do Line 1562  for dir in $TESTDIRS ; do
1562      fi      fi
1563    
1564      if test "x$MPI" != "x0" ; then      if test "x$MPI" != "x0" ; then
1565          prefer_X=0          ntx=1 ; nty=1
1566          if test "x$MULTI_THREAD" = "xt" ; then          if test "x$MULTI_THREAD" = "xt" ; then
1567              retv=`check_eedata $dir"/input/eedata.mth"`            ff=$dir"/input/eedata.mth"
1568              if test $retv = 1 ; then prefer_X=1 ; fi            ntx=`grep "^ *nTx *=" $ff | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
1569              nty=`grep "^ *nTy *=" $ff | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
1570              if test "x$ntx" = x ; then ntx=1 ; fi
1571              if test "x$nty" = x ; then nty=1 ; fi
1572          fi          fi
1573          #- create new SIZE.h with no more than '$MPI' Procs          #- create new SIZE.h with no more than '$MPI' Procs
1574          mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI $prefer_X          mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI $ntx $nty
1575          LOC_NPROC=$?          LOC_NPROC=$?
1576          (   cd $BUILD_DIR          (   cd $BUILD_DIR
1577              if test -r SIZE.h.mpi ; then              if test -r SIZE.h.mpi ; then
# Line 1404  for dir in $TESTDIRS ; do Line 1611  for dir in $TESTDIRS ; do
1611      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1612      extra_runs=      extra_runs=
1613      if test "x$NORUN" = xf ; then      if test "x$NORUN" = xf ; then
1614          ex_run_dirs=`( cd $dir ; echo $inputdir.* )`          ex_run_dirs=`( cd $dir ; ls -d $inputdir.* 2> /dev/null )`
1615      fi      fi
1616      #echo "ex_run_dirs='$ex_run_dirs'"      #echo "ex_run_dirs='$ex_run_dirs'"
1617      for exd in $ex_run_dirs ; do      for exd in $ex_run_dirs ; do
1618          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1619          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1620          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
1621          if test -f $outf -a -r $outf ; then          if test -r $outf -o -r ${outf}.gz ; then
1622            if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1623              if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1624                if test "x$MPI" = "x0" ; then                if test "x$MPI" = "x0" ; then
# Line 1434  for dir in $TESTDIRS ; do Line 1641  for dir in $TESTDIRS ; do
1641    
1642      echo      echo
1643      if test "x$extra_runs" = "x" ; then      if test "x$extra_runs" = "x" ; then
1644         echo "Experiment:  $dir"          echo "Experiment:  $dir"
1645      else      else
1646         echo "Experiment:  $dir ; extra_runs=$extra_runs"          echo "Experiment:  $dir ; extra_runs=$extra_runs"
1647      fi      fi
1648      echo      echo
1649      unset genmake makedepend make run      unset genmake makedepend make run
# Line 1455  for dir in $TESTDIRS ; do Line 1662  for dir in $TESTDIRS ; do
1662              run=N              run=N
1663          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1664              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1665              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1666              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1667              && makemodel $dir/$builddir && make=Y              && makemodel $dir/$builddir && make=Y
1668                echo
1669      else      else
1670          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1671              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1672              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1673              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1674              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1675              && run_clean $dir/$rundir \              && run_clean $dir/$rundir \
1676              && linkdata $dir/$rundir $inputdir \              && linkdata $dir/$rundir $inputdir \
1677              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1678              && results=`testoutput_run $dir $rundir $ref_outp`              && results=`testoutput_run $dir $rundir $ref_outp`
1679                echo 1>&2
1680      fi      fi
1681      #echo "results='$results'"      #echo "results='$results'"
1682    
1683          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1684          echo 1>&2          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
         echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY  
1685          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
1686    
1687          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1688              unset run              unset run
1689              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1690              #  reference output file              #  reference output file
1691              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1692              #  Create an output dir & summary.txt file for each extra run (tdir.ex)              #  Create an output dir & summary.txt file for each extra run (tdir.ex)
# Line 1494  for dir in $TESTDIRS ; do Line 1702  for dir in $TESTDIRS ; do
1702              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir
1703              runmodel $dir/$pfxdir.$ex && run=Y \              runmodel $dir/$pfxdir.$ex && run=Y \
1704              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`
             fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`  
             fres="$fres.$ex"  
1705              echo 1>&2              echo 1>&2
1706    
1707                fres=`formatresults $dir.$ex ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1708              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1709              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
1710              if test "x$POSTCLEAN" = x2 ; then              if test "x$POSTCLEAN" = x2 ; then
# Line 1504  for dir in $TESTDIRS ; do Line 1712  for dir in $TESTDIRS ; do
1712              fi              fi
1713          done          done
1714    
1715      if test -f $DRESULTS"/"genmake_state ; then : ; else      if test ! -f $DRESULTS"/"genmake_state ; then
1716          if test -f $dir/$builddir/Makefile ; then          if test -f $dir/$builddir/Makefile ; then
1717              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`
1718              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state
1719              sed -n '/^# executed by:/,+1 p' $dir/$builddir/Makefile >> $DRESULTS/genmake_state  #           sed -n '/^# executed by:/,+1 p' $dir/$builddir/Makefile >> $DRESULTS/genmake_state
1720    # bsd-sed cannot do the above code
1721                cat $dir/$builddir/Makefile | \
1722                    sed -n '/^# executed by:/{N
1723                                              p
1724                                              }' >> $DRESULTS/genmake_state
1725              echo " $mkOpt" >> $DRESULTS/genmake_state              echo " $mkOpt" >> $DRESULTS/genmake_state
1726              if test "x$OPTFILE" = xNONE ; then              if test "x$OPTFILE" = xNONE ; then
1727                  eval $mkOpt                  eval $mkOpt
1728                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\  #               sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\
1729                          $SUMMARY > tr_0.tmp_log  #                       $SUMMARY > tmp.tr_log
1730    # bsd-sed requires a newline after "a\":
1731                    sed "/^No \"OPTFILE\" was specified ; genmake2/a\\
1732                             OPTFILE=${OPTFILE}" $SUMMARY > tmp.tr_log
1733                  RETVAL=$?                  RETVAL=$?
1734                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY                  if test "x$RETVAL" = x0 ; then
1735                          cp tr_0.tmp_log $SUMMARY                      cp -f tmp.tr_log $SUMMARY
                 else rm -f tr_0.tmp_log  
1736                  fi                  fi
1737                    rm -f tmp.tr_log
1738              fi              fi
1739              gmkLog=$dir/$builddir/genmake.log              gmkLog=$dir/$builddir/genmake.log
1740              grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1              if test -r $gmkLog ; then
1741              RETVAL=$?                  grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1
1742              if test "x$RETVAL" = x0 ; then                  RETVAL=$?
1743                  echo "from '$gmkLog', extract compiler version:" >> $DRESULTS/genmake_state                  if test "x$RETVAL" = x0 ; then
1744                  sed -n '/Get compiler version/,/<-- compiler version/p' $gmkLog \                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1745                         | grep -v '^... compiler version ' > tr_1.tmp_log                    echo "extract compiler version:"   >> $DRESULTS/genmake_state
1746                  sed -n '1,/^$/p' tr_1.tmp_log | sed '/^$/d' | sed 's/^./ &/' \                    sed -n '/Get compiler version/,/<-- compiler version/p' \
1747                          >> $DRESULTS/genmake_state                       $gmkLog | grep -v '^... compiler version ' > tmp.tr_log
1748                  rm -f tr_1.tmp_log                    sed -n '1p' tmp.tr_log >> $DRESULTS/genmake_state
1749                      sed -n '2,/^$/p' tmp.tr_log | sed '/^$/d' | sed 's/^./ &/' \
1750                                             >> $DRESULTS/genmake_state
1751                      rm -f tmp.tr_log
1752                    fi
1753                fi
1754                gmkLog=$dir/$builddir/genmake_state
1755                if test -r $gmkLog ; then
1756                    echo -n "from '$gmkLog', "      >> $DRESULTS/genmake_state
1757                    echo "get genmake settings:"    >> $DRESULTS/genmake_state
1758                    sed -n '/^HAVE_/p' $gmkLog | sed 's/^./ &/' \
1759                                                    >> $DRESULTS/genmake_state
1760              fi              fi
1761          fi          fi
1762      fi      fi
1763      #postclean $dir/$builddir      #postclean $dir/$builddir
1764      if test "x$POSTCLEAN" = x2 ; then      if test "x$POSTCLEAN" = x2 ; then
1765          makeclean $dir/$builddir \          makeclean $dir/$builddir \
1766              && run_clean $dir/$rundir              && run_clean $dir/$rundir
1767      fi      fi
1768      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi
1769    
# Line 1554  date >> $SUMMARY Line 1781  date >> $SUMMARY
1781  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
1782      echo "No results email was sent."      echo "No results email was sent."
1783  else  else
1784      if test "x$HAVE_MPACK" = xt ; then      if test "x$SENDCMD" != x ; then
1785          tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \          SendOpt='' ; headCMD=`echo $SENDCMD | awk '{print $1}'`
1786              && gzip $DRESULTS".tar" \          if test $headCMD != 'scp' ; then SendOpt='-s MITgcm-test -m 3555000' ; fi
1787              && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES          if [ $verbose -gt 1 ]; then
1788               echo " run: $SENDCMD $SendOpt ${SAVDIR}/${DRESULTS}".tar.gz" $ADDRESSES"
1789            fi
1790            tar -cf ${SAVDIR}/${DRESULTS}".tar" $DRESULTS > /dev/null 2>&1 \
1791                && gzip ${SAVDIR}/${DRESULTS}".tar" \
1792                && $SENDCMD $SendOpt ${SAVDIR}/${DRESULTS}".tar.gz" $ADDRESSES
1793          RETVAL=$?          RETVAL=$?
1794          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1795              echo              echo
1796              echo "Warning: The tar, gzip, & mpack step failed.  Please send email"              echo "Warning: The tar, gzip, & $SENDCMD step failed.  Please send email"
1797              echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "              echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
1798              echo "  summary of results from the directory \"$DRESULTS\"."              echo "  summary of results from the directory \"$DRESULTS\"."
1799              echo              echo
# Line 1570  else Line 1802  else
1802              echo "An email containing results was sent to the following addresses:"              echo "An email containing results was sent to the following addresses:"
1803              echo "  \"$ADDRESSES\""              echo "  \"$ADDRESSES\""
1804              echo              echo
1805              test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"              test -f ${SAVDIR}/${DRESULTS}".tar" &&  rm -f ${SAVDIR}/${DRESULTS}".tar"
1806              test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"              test -f ${SAVDIR}/${DRESULTS}".tar.gz" &&  rm -f ${SAVDIR}/${DRESULTS}".tar.gz"
1807          fi          fi
1808      fi      fi
1809  fi  fi
# Line 1583  fi Line 1815  fi
1815  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1816      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1817      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1818          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1819      fi      fi
1820      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1821  fi  fi
# Line 1591  fi Line 1823  fi
1823  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then
1824      rm -rf $DRESULTS      rm -rf $DRESULTS
1825  fi  fi
1826    echo "======== End of testreport execution ========"

Legend:
Removed from v.1.163  
changed lines
  Added in v.1.212

  ViewVC Help
Powered by ViewVC 1.1.22